package Site::Template::DocTree;
# LICENSE
#
# Copyright (c) 2001 Steve Slaven <bpk@hoopajoo.net> All rights reserved.
#
# This program is free software  and is provided "as is" without
# express or implied warranty. You can redistribute it and/or
# modify it under the same terms as Perl itself.
#

use strict;
use vars qw( %AUTOFIELDS @ISA );

use PObject;
@ISA = qw( PObject );

%AUTOFIELDS = (
	parent => undef,
	type => undef,
	data => undef,
	children => undef,
	haschildren => undef );

sub OBJ_NEW
{
	my $Self = shift();

	$Self -> children( [] );

	return( $Self );
}

sub newchild
{
	my $Self = shift;

	push( @{ $Self -> children() }, Site::Template::DocTree -> new() );
	$Self -> children() -> [ -1 ] -> parent( $Self );

	$Self -> haschildren( 1 );

	return( $Self -> children() -> [ -1 ] );
}

sub dumptree
{
	my $Self = shift;
	my $Prefix = shift;

	print $Prefix . $Self -> type();

	if( $Self -> type() eq "TAG" )
	{
		print "  " . $Self -> data() -> tag() . "\n";
	}
	else
	{
		print "\n";
	}

	for ( @{ $Self -> children() } )
	{
		$_ -> dumptree( $Prefix . " " );
	}

}

sub set
{
	my $Self = shift;

	$Self -> { data } = shift;
}

sub getparent
{
	my $Self = shift;

	if( $Self -> parent() )
	{
		return( $Self -> parent() );
	}
	else
	{
		$Self -> _dfatal( "Accessed null parent: " . $Self -> data()  );
	}
}

sub add
{
	my $Self = shift;
	$Self -> { data } .= shift();
}

1;
